%es 5 MASB
dt=0.25

%s(t)=3cos(pi*t/3)+4*sin(pi*t/5) somma di funzioni periodiche di periodo 6
%e 10 s. Il periodo  30 s.

T0=30

t=0:dt:T0-dt;
s=3*cos(pi*t/3)+4*sin(pi*t/5);
N=length(t); % pari
df=1/(N*dt);

f=df*[-N/2:N/2-1];

S=fft(s)/N;
figure
stem(f,abs(fftshift(S)));

figure
stem(f,angle(fftshift(S)));

T=40;
t=0:dt:T-dt;
v=3*cos(pi*t/3)+4*sin(pi*t/5);
df=0.02;
Nzp=1/(df*dt);% pari

V=fft(v,Nzp);

f=df*[-Nzp/2:Nzp/2-1];

figure
stem(f,abs(fftshift(V)));
figure
stem(f,angle(fftshift(V)));

B=[1 1.8 0.82];
A=[1 0.8];
delta=[1 zeros(1,15)];
imp=filter(B,A,delta);

df=0.01;
Nzp=1/(df*dt); % pari
f=df*[-Nzp/2:Nzp/2-1];
IMP=fft(imp,Nzp);

figure
plot(f,abs(fftshift(IMP)));
figure
plot(f,angle(fftshift(IMP)));

out_1=conv(imp,v);

out_2=filter(B,A,v);

%modifico la fase del polo di pi (lascio invariato il polo nell'origine)
%modifico la fase degli zeri di pi

A1=[ 1 -0.8];

B=[1 1.8 0.82];
z=roots(B)
z1=-z;
B1=poly(z1) %A1=[1 -1.8 0.82];

% provare
% figure
% freqz(B1,A1)
% figure
% freqz(B,A)
% 






